<?php

defined('_PS_VERSION_') or die();

require_once _PS_MODULE_DIR_ . 'lecmprepass/helpers/abstract.php';

class LeCMPPHelperNopcommerce extends LeCMPPHelperAbstract
{
    public function validatePassword($passwd, $encrypt)
    {
        $check = false;
        $hash = $this->convertHashToEncryptAndSalt($encrypt);
        if(!$hash){
            return $check;
        }
        $encrypted = $hash['encrypt'];
        $salt = $hash['salt'];
        $password_hash = $this->hashPassword($passwd, $salt);
        return $encrypted == $password_hash;
    }

    public function hashPassword($password, $salt)
    {
        $concat = $password . $salt;
        return strtoupper(sha1($concat));
    }

    public function convertHashToEncryptAndSalt($hash)
    {
        $split = explode(':', $hash);
        $encrypt = isset($split[0]) ? $split[0] : false;
        $salt = isset($split[1]) ? $split[1] : false;
        if(!$encrypt || !$salt){
            return false;
        }
        return array(
            'encrypt' => $encrypt,
            'salt' => $salt,
        );
    }

    /**
     * Password hash in db save with construct: Password:PasswordSalt
     * Code hash password of nopCommerce in file: Libraries\Nop.Services\Security\EncryptionService.cs
     */
}
