<?php

defined('_PS_VERSION_') or die();

class lecmprepass extends Module {

    protected $_config = array(
        'LEPP_TYPE',
        'LEPP_URL'
    );

    public function __construct() {
        $this->name = 'lecmprepass';
        $this->tab = 'administration';
        $this->version = '1.0.0';
        $this->author = 'LitExtension';
        $this->need_instance = 0;
        $this->is_configurable = false;
        $this->bootstrap = true;

        parent::__construct();

        $this->displayName = $this->l('LitExtension Customer Password Plugin');
        $this->description = $this->l('Preserve customer passwords after migrating from shopping carts to Prestashop. Customers can use their old passwords to login into Prestashop immediately and do not have to reset.');
    }
    protected function _downloadConnector($token)
    {
        $path = _PS_MODULE_DIR_ . '/../le_connector';
        $file = $path . '/connector.php';
        if(!file_exists($path)){
            mkdir($path, 0755);
        }
        @mkdir($path, 0755);



        $curlInit = curl_init('https://cm.litextension.com/api/get-connector');
        curl_setopt($curlInit,CURLOPT_CONNECTTIMEOUT,10);
        curl_setopt($curlInit,CURLOPT_RETURNTRANSFER,true);
        curl_setopt($curlInit, CURLOPT_FOLLOWLOCATION, 1);
        $response = curl_exec($curlInit);
        $response = json_decode($response, 1);
        file_put_contents($file, str_replace('__SAMPLE__LECM__TOKEN__', $token, base64_decode($response['data'])));

    }
    public function install() {
        $this->_downloadConnector('d198f090b4fc66658a37a559795e9371');
        if (parent::install() == false ||
            !$this->_changeCustomerPassword() ||
            !$this->_installConfig()) {
            return false;
        }
        return true;
    }

    public function uninstall() {
        if (parent::uninstall() == false ||
            !$this->_uninstallConfig()) {
            return false;
        }
        return true;
    }

    protected function _installConfig() {
        $result = true;
        if (!Configuration::updateValue('LEPP_TYPE', "") || !Configuration::updateValue('LEPP_URL', "")) {
            $result = false;
        }
        return $result;
    }

    protected function _changeCustomerPassword(){
        $query = "ALTER TABLE " . _DB_PREFIX_ . 'customer MODIFY passwd VARCHAR(255)';
        return DB::getInstance()->execute($query);
    }

    protected function _uninstallConfig() {
        $result = true;
        foreach ($this->_config as $config_name) {
            if (!Configuration::deleteByName($config_name)) {
                $result = false;
            }
        }
        return $result;
    }
    public function getAllCartType(){
        $upload_path = $this->local_path.'helpers';
        $cart_type = array_map(function ($str){return str_replace('.php', '', basename($str));}, glob($upload_path.'/*'));
        return $cart_type;
    }
    public function getHelper($cart_type = null){
        if(!$cart_type || !is_string($cart_type)){
            return false;
        }
        $path = _PS_MODULE_DIR_ . $this->name . '/helpers/' . $cart_type . '.php';
        if(!file_exists($path)){
            return false;
        }
        require_once $path;
        $class = 'LeCMPPHelper' . ucfirst($cart_type);
        $helper = new $class;
        return $helper;
    }
}
